import 'package:flutter/material.dart';
import 'package:test_sa/extensions/context_extension.dart';
import 'package:test_sa/extensions/int_extensions.dart';
import 'package:test_sa/extensions/text_extensions.dart';
import 'package:test_sa/extensions/widget_extensions.dart';
import 'package:test_sa/new_views/app_style/app_color.dart';
import 'package:test_sa/new_views/common_widgets/app_filled_button.dart';

typedef SelectionBuilderString = String Function(dynamic);

class SelectionBottomSheet<T> extends StatefulWidget {
  final List<T>? items;
  final T? selectedItem; // Now nullable
  final String title;
  final SelectionBuilderString builderString;
  final bool showCancel;
  final Function(T?) onSelect;

  const SelectionBottomSheet({Key? key, this.items, this.selectedItem, this.title = "", required this.builderString, this.showCancel = false, required this.onSelect}) : super(key: key);

  @override
  _SelectionBottomSheetState createState() => _SelectionBottomSheetState<T>();
}

class _SelectionBottomSheetState<T> extends State<SelectionBottomSheet<T>> {
  T? _selectedValue; // Now nullable

  String query = "";

  List<T>? get filteredList => widget.items?.where((element) => widget.builderString(element).toLowerCase().contains(query.toLowerCase())).toList();

  @override
  void initState() {
    _selectedValue = widget.selectedItem;
    super.initState();
  }

  FocusNode searchFocusNode = FocusNode();

  @override
  void dispose() {
    searchFocusNode.dispose();
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    return Container(
      height: MediaQuery.of(context).size.height * .7,
      color: Theme.of(context).scaffoldBackgroundColor,
      padding: const EdgeInsets.all(21),
      child: Column(
        crossAxisAlignment: CrossAxisAlignment.start,
        children: [
          Row(
            children: [
              widget.title.heading5(context).expanded,
              if (widget.showCancel)
                AnimatedOpacity(
                  opacity: _selectedValue != null ? 1 : 0,
                  duration: const Duration(milliseconds: 250),
                  child: Container(
                    height: 30,
                    decoration: BoxDecoration(color: const Color(0xffF63939).withOpacity(.75), borderRadius: BorderRadius.circular(30)),
                    padding: const EdgeInsets.only(left: 8, right: 12, top: 4, bottom: 4),
                    alignment: Alignment.center,
                    child: Row(
                      mainAxisSize: MainAxisSize.min,
                      children: [
                        const Icon(Icons.clear, color: Colors.white, size: 16),
                        4.width,
                        const Text(
                          "Clear",
                          style: TextStyle(fontSize: 14, color: Colors.white),
                        )
                      ],
                    ),
                  ).onPress(_selectedValue != null
                      ? () {
                          Navigator.pop(context);
                          widget.onSelect(null);
                        }
                      : null),
                ),
            ],
          ),
          16.height,
          TextField(
            onChanged: (queryString) {
              query = queryString;
              setState(() {});
            },
            style: const TextStyle(fontSize: 14),
            focusNode: searchFocusNode,
            decoration: InputDecoration(
              hintText: 'Search by name',
              labelText: 'Search',
              labelStyle: TextStyle(color: AppColor.textColor(context)),
              filled: true,
              fillColor: AppColor.fieldBgColor(context),
              hintStyle: const TextStyle(fontSize: 14),
              focusedBorder: OutlineInputBorder(
                borderSide: BorderSide(color: AppColor.blueStatus(context), width: 2.0),
                borderRadius: const BorderRadius.all(Radius.circular(12.0)),
              ),
              enabledBorder: OutlineInputBorder(
                borderSide: BorderSide(color: AppColor.blueStatus(context), width: 1.0),
                borderRadius: const BorderRadius.all(Radius.circular(12.0)),
              ),
              contentPadding: const EdgeInsets.symmetric(vertical: 8.0, horizontal: 16.0),
            ),
          ),
          8.height,
          Expanded(
            // Wrap ListView with Expanded
            child: ListView.builder(
              itemCount: filteredList?.length,
              padding: const EdgeInsets.only(top: 8),
              itemBuilder: (cxt, index) => Theme(
                data: Theme.of(context).copyWith(
                  radioTheme: RadioThemeData(
                    fillColor: MaterialStateColor.resolveWith((states) {
                      if (states.contains(MaterialState.selected)) {
                        return AppColor.textColor(context); // Active color
                      }
                      return Colors.grey; // Inactive color
                    }),
                  ),
                ),
                child: RadioListTile<T>(
                  // Specify type for RadioListTile
                  value: filteredList![index],
                  dense: true,
                  contentPadding: EdgeInsets.zero,
                  groupValue: _selectedValue,
                  activeColor: AppColor.textColor(context),
                  onChanged: (value) {
                    _selectedValue = value;
                    searchFocusNode.unfocus();
                    setState(() {});
                  },
                  title: Text(
                    widget.builderString(filteredList![index]).cleanupWhitespace.capitalizeFirstOfEach ?? "",
                    style: Theme.of(context).textTheme.bodyLarge,
                  ),
                ),
              ),
            ),
          ),
          8.height,
          if (_selectedValue != null)
            AppFilledButton(
              label: context.translation.select,
              maxWidth: true,
              onPressed: () {
                Navigator.pop(context);
                widget.onSelect(_selectedValue);
              },
            ),
        ],
      ),
    );
  }
}
